package nc.bs.mmpac.pmo.pfxx.plugin;

import nc.bs.framework.common.NCLocator;
import nc.bs.pfxx.ISwapContext;
import nc.bs.pfxx.plugin.AbstractPfxxPlugin;
import nc.itf.mmpac.pmo.pac0002.IPMOMaintainService;
import nc.vo.mmpac.pmo.pac0002.entity.PMOAggVO;
import nc.vo.pfxx.auxiliary.AggxsysregisterVO;
import nc.vo.pfxx.util.PfxxPluginUtils;
import nc.vo.pub.AggregatedValueObject;
import nc.vo.pub.BusinessException;
import nc.vo.pub.CircularlyAccessibleValueObject;
import nc.vo.pubapp.pattern.pub.PubAppTool;

public class MMpacPmoPfxxPlugin extends AbstractPfxxPlugin {
	private IPMOMaintainService service = null;

	private IPMOMaintainService getIPMOMaintainService() {
		if (this.service == null) {
			this.service = (IPMOMaintainService) NCLocator.getInstance().lookup(IPMOMaintainService.class);
		}

		return this.service;
	}

	protected Object processBill(Object vo, ISwapContext swapContext, AggxsysregisterVO aggxsysvo)
			throws BusinessException {
		AggregatedValueObject resvo = (AggregatedValueObject) vo;
		String vopk = PfxxPluginUtils.queryBillPKBeforeSaveOrUpdate(swapContext.getBilltype(), swapContext.getDocID());
		AggregatedValueObject returnVO = null;
		if (PubAppTool.isNull(vopk)) {
			resvo.getParentVO().setStatus(2);
			CircularlyAccessibleValueObject[] arr$ = resvo.getChildrenVO();
			int len$ = arr$.length;

			for (int i$ = 0; i$ < len$; ++i$) {
				CircularlyAccessibleValueObject bvo = arr$[i$];
				bvo.setStatus(2);
			}

			returnVO = this.getIPMOMaintainService().insert(new PMOAggVO[]{(PMOAggVO) resvo})[0];
			//   2022-11-08  yaoy   
			if(swapContext.getBilltype().equals("55A2")){
				returnVO.getParentVO().setAttributeValue("fbillstatus",1);
				this.getIPMOMaintainService().approve(new PMOAggVO[]{(PMOAggVO) resvo});
		    }
		} else {
			returnVO = this.getIPMOMaintainService().update(new PMOAggVO[]{(PMOAggVO) resvo})[0];
		}

		vopk = returnVO.getParentVO().getPrimaryKey();
		PfxxPluginUtils.addDocIDVsPKContrast(swapContext.getBilltype(), swapContext.getDocID(), vopk);
		return vopk;
	}
}